/*
  AMS-random Library
  part of Arduino Mega Server project
  
  version 0.17
  2016, Hi-Lab.ru
  
  License: Free, without any warranties
  Home:    http://hi-lab.ru/arduino-mega-server (russian)
           http://hi-lab.ru/english/arduino-mega-server (english)
  Email:   info@hi-lab.ru
  
  IDE: Arduino 1.6.5 r2
*/

#ifndef AMS_random_cpp
#define AMS_random_cpp

#include "AMS-random.h"

// Arduino Pro Mini by default
byte maxAnalogPorts  =  7;
byte maxDigitalPorts = 13;

byte buffId[MAX_ID_DIGS];

int getSeed() {
  int seed = 0;
  //Serial.print("maxAnalogPorts: "); Serial.println(maxAnalogPorts);
  for (int i = 0; i < maxAnalogPorts;  i++) {seed +=  analogRead(i);}
  for (int i = 0; i < maxDigitalPorts; i++) {seed += digitalRead(i);} 
  return seed;
}

long getMagic() {
  long magic = 0;
  getSeed();
  for (int i = 0; i < random(9, 200); i++) {
    randomSeed(getSeed());
    for (int j = 0; j < random(9, 9999) + 1; j++) {
      magic += random(9, 9999);
    }
  }
  return magic;
}

void setRandom() {
  randomSeed(getMagic());
}

void generateId() {
  setRandom();
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    buffId[i] = idCode[random(0, MAX_CODE)];
  }
}

boolean validIdChar(byte b) {
  for (byte i = 0; i < MAX_CODE; i++) {
    if (idCode[i] == b) {return true;}
  }
  return false;
}

void printId(String prefix, String suffix) {
  Serial.print(prefix);
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    Serial.print(char(buffId[i]));
    if (i == 4 || i == 9) {
      Serial.print("-");  
    }
  }
  Serial.print(suffix);
}

String stringId() {
  String s = "";
  for (byte i = 0; i < MAX_ID_DIGS; i++) {
    s += char(buffId[i]);
  }
  return s;
}

#endif // #ifndef AMS_random_cpp
